#include "Precompiled.h"

#include <ta_libc.h>
#include <stdlib.h>

#include "AsirikuyMachineLearningCWrapper.hpp"
#include "EasyTradeCWrapper.hpp"
#include "OrderSignals.h"
#include "OrderManagement.h"
#include "AsirikuyTime.h"

static double lastPrediction;

typedef enum additionalSettings_t
{
	NUMBER_OF_EXAMPLES   = ADDITIONAL_PARAM_1,
	BARS_USED            = ADDITIONAL_PARAM_2
} AdditionalSettings;

AsirikuyReturnCode runMachineLearningTest(StrategyParams* pParams)
{
  AsirikuyReturnCode returnCode = SUCCESS;
  double stopLoss, takeProfit, atr;
  double ensemblePrediction = 0;

  atr = iAtr(DAILY_RATES, 20, 1);
  
  stopLoss   =  atr*parameter(SL_ATR_MULTIPLIER);
  takeProfit =  atr*parameter(TP_ATR_MULTIPLIER);

  ensemblePrediction += LR_Prediction_i_simpleReturn_o_simpleReturn((int)parameter(NUMBER_OF_EXAMPLES), (int)parameter(BARS_USED));

  if(ensemblePrediction > 0)
	{
    return openOrUpdateLongEasy(0, stopLoss);
  }
	else if(ensemblePrediction < 0)
	{
    return openOrUpdateShortEasy(0, stopLoss);
  }

  return SUCCESS;
}
